# deque Class Template Reference
[Containers, Sequences]

List of all members.

## Detailed Description

### template<typename _Tp, typename _Alloc = allocator<_Tp>>
class std::deque< _Tp, _Alloc >

Meets the requirements of a container, a reversible container, and a sequence, including the optional sequence requirements.

In previous HP/SGI versions of deque, there was an extra template parameter so users could control the node size. This extension turned out to violate the C++ standard (it can be detected using template template parameters), and it was removed.

Definition at line 591 of file stl_deque.h.

## Public Types

- typedef _Base::allocator_type allocator_type
- typedef _Base::const_iterator const_iterator
- typedef _Alloc::const_pointer const_pointer
- typedef _Alloc::const_reference const_reference
- typedef std::reverse_iterator<
  const_iterator > const_reverse_iterator
- typedef ptrdiff_t difference_type
- typedef _Base::iterator iterator
- typedef _Alloc::pointer pointer
- typedef _Alloc::reference reference
- typedef std::reverse_iterator<
  iterator > reverse_iterator
- typedef size_t size_type
- typedef _Tp value_type

## Public Member Functions

- template<typename _InputIterator> void assign (_InputIterator __first, _InputIterator __last)
- void assign (size_type __n, const value_type &__val)
- const_reference at (size_type __n) const
- reference at (size_type __n)
- const_reference back () const
- reference back ()
- const_iterator begin () const
- iterator begin ()
- void clear ()
- template<typename _InputIterator> deque (_InputIterator __first, _InputIterator __last, const allocator_type &__a=allocator_type())
- deque (const deque &__x)
- deque (size_type __n)
- deque (size_type __n, const value_type &__value, const allocator_type &__a=allocator_type())
- deque (const allocator_type &__a=allocator_type())
- bool empty () const
- const_iterator end () const
- iterator end ()
- iterator erase (iterator __first, iterator __last)
- iterator erase (iterator __position)
- const_reference front () const
- reference front ()
- allocator_type get_allocator () const
- template<typename _InputIterator> void insert (iterator __position, _InputIterator __first, _InputIterator __last)
- void insert (iterator __position, size_type __n, const value_type &__x)
- iterator insert (iterator position, const value_type &__x)
- size_type max_size () const
- deque & operator= (const deque &__x)
- const_reference operator[] (size_type __n) const
- reference operator[] (size_type __n)
- void pop_back ()
- void pop_front ()
- void push_back (const value_type &__x)
- void push_front (const value_type &__x)
- const_reverse_iterator rbegin () const
- reverse_iterator rbegin ()
- const_reverse_iterator rend () const
- reverse_iterator rend ()
- void resize (size_type new_size)
- void resize (size_type __new_size, const value_type &__x)
- size_type size () const
- void swap (deque &__x)
- ~deque ()

## Protected Types

- typedef pointer * _Map_pointer

## Protected Member Functions

- template<typename _ForwardIterator> void _M_assign_aux (_ForwardIterator __first, _ForwardIterator __last, forward_iterator_tag)
- template<typename _InputIterator> void _M_assign_aux (_InputIterator __first, _InputIterator __last, input_iterator_tag)
- template<typename _InputIterator> void _M_assign_dispatch (_InputIterator __first, _InputIterator __last, __false_type)
- template<typename _Integer> void _M_assign_dispatch (_Integer __n, _Integer __val, __true_type)
- void _M_fill_assign (size_type __n, const value_type &__val)
- void _M_fill_initialize (const value_type &__value)
- void _M_fill_insert (iterator __pos, size_type __n, const value_type &__x)
- template<typename _InputIterator> void _M_initialize_dispatch (_InputIterator __first, _InputIterator __last, __false_type)
- template<typename _Integer> void _M_initialize_dispatch (_Integer __n, _Integer __x, __true_type)
- template<typename _ForwardIterator> void _M_insert_aux (iterator __pos, _ForwardIterator __first, _ForwardIterator __last, size_type __n)
- void _M_insert_aux (iterator __pos, size_type __n, const value_type &__x)
- iterator _M_insert_aux (iterator __pos, const value_type &__x)
- template<typename _InputIterator> void _M_insert_dispatch (iterator __pos, _InputIterator __first, _InputIterator __last, __false_type)
- template<typename _Integer> void _M_insert_dispatch (iterator __pos, _Integer __n, _Integer __x, __true_type)
- void _M_new_elements_at_back (size_type __new_elements)
- void _M_new_elements_at_front (size_type __new_elements)
- void _M_pop_back_aux ()
- void _M_pop_front_aux ()
- void _M_push_back_aux (const value_type &)
- void _M_push_front_aux (const value_type &)
- void _M_range_check (size_type __n) const
- template<typename _ForwardIterator> void _M_range_initialize (_ForwardIterator __first, _ForwardIterator __last, forward_iterator_tag)
- template<typename _InputIterator> void _M_range_initialize (_InputIterator __first, _InputIterator __last, input_iterator_tag)
- template<typename _ForwardIterator> void _M_range_insert_aux (iterator __pos, _ForwardIterator __first, _ForwardIterator __last, forward_iterator_tag)
- template<typename _InputIterator> void _M_range_insert_aux (iterator __pos, _InputIterator __first, _InputIterator __last, input_iterator_tag)
- void _M_reallocate_map (size_type __nodes_to_add, bool __add_at_front)
- iterator _M_reserve_elements_at_back (size_type __n)
- iterator _M_reserve_elements_at_front (size_type __n)
- void _M_reserve_map_at_back (size_type __nodes_to_add=1)
- void _M_reserve_map_at_front (size_type __nodes_to_add=1)

## Static Protected Member Functions

- static size_t _S_buffer_size ()

## Constructor & Destructor Documentation

deque | ( | const allocator_type & | __a = `allocator_type()` | ) | `[inline, explicit]`

| Default constructor creates no elements. Definition at line 641 of file stl_deque.h.

deque | ( | size_type | __n,
|  | const value_type & | __value,
|  | const allocator_type & | __a = `allocator_type()`
| ) | `[inline]`

Create a deque with copies of an exemplar element.

Parameters:

  | n | The number of elements to initially create.
  | value | An element to copy.

This constructor fills the deque with n copies of value.

Definition at line 651 of file stl_deque.h.

deque | ( | size_type | __n | ) | `[inline, explicit]`

Create a deque with default elements.

Parameters:

  | n | The number of elements to initially create.

This constructor fills the deque with n copies of a default-constructed element.

Definition at line 664 of file stl_deque.h.

deque | ( | const deque< _Tp, _Alloc > & | __x | ) | `[inline]`

Deque copy constructor.

Parameters:

  | x | A deque of identical element and allocator types.

The newly-created deque uses a copy of the allocation object used by x.

Definition at line 675 of file stl_deque.h.

References deque::begin(), deque::end(), and deque::get_allocator().

deque | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | const allocator_type & | __a = `allocator_type()`
| ) | `[inline]`

Builds a deque from a range.

Parameters:

  | first | An input iterator.
  | last | An input iterator.

Create a deque consisting of copies of the elements from [first, last).

If the iterators are forward, bidirectional, or random-access, then this will call the elements' copy constructor N times (where N is distance(first,last)) and do no memory reallocation. But if only input iterators are used, then this will do at most 2N calls to the copy constructor, and logN memory reallocations.

Definition at line 696 of file stl_deque.h.

~deque | ( |  | ) | `[inline]`

| The dtor only erases the elements, and note that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty. Definition at line 710 of file stl_deque.h.

## Member Function Documentation

void assign | ( | _InputIterator | __first,
|  | _InputIterator | __last
| ) | `[inline]`

Assigns a range to a deque.

Parameters:

  | first | An input iterator.
  | last | An input iterator.

This function fills a deque with copies of the elements in the range [first,last).

Note that the assignment completely changes the deque and that the resulting deque's size is the same as the number of elements assigned. Old data may be lost.

Definition at line 752 of file stl_deque.h.

void assign | ( | size_type | __n,
|  | const value_type & | __val
| ) | `[inline]`

Assigns a given value to a deque.

Parameters:

  | n | Number of elements to be assigned.
  | val | Value to be assigned.

This function fills a deque with n copies of the given value. Note that the assignment completely changes the deque and that the resulting deque's size is the same as the number of elements assigned. Old data may be lost.

Definition at line 735 of file stl_deque.h.

const_reference at | ( | size_type | __n | ) | const`[inline]`

Provides access to the data contained in the deque.

Parameters:

  | n | The index of the element for which data should be accessed.

Returns:
  Read-only (constant) reference to data.

Exceptions:

  | std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the deque. The function throws out_of_range if the check fails.

Definition at line 957 of file stl_deque.h.

reference at | ( | size_type | __n | ) | `[inline]`

Provides access to the data contained in the deque.

Parameters:

  | n | The index of the element for which data should be accessed.

Returns:
  Read/write reference to data.

Exceptions:

  | std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the deque. The function throws out_of_range if the check fails.

Definition at line 939 of file stl_deque.h.

const_reference back | ( |  | ) | const`[inline]`

| Returns a read-only (constant) reference to the data at the last element of the deque. Definition at line 996 of file stl_deque.h. References deque::end().

reference back | ( |  | ) | `[inline]`

| Returns a read/write reference to the data at the last element of the deque. Definition at line 984 of file stl_deque.h. References deque::end().

const_iterator begin | ( |  | ) | const`[inline]`

| Returns a read-only (constant) iterator that points to the first element in the deque. Iteration is done in ordinary element order. Definition at line 777 of file stl_deque.h.

iterator begin | ( |  | ) | `[inline]`

| Returns a read/write iterator that points to the first element in the deque. Iteration is done in ordinary element order. Definition at line 769 of file stl_deque.h. Referenced by deque::deque(), deque::front(), deque::operator=(), and std::operator==().

void clear | ( |  | ) |

| Erases all the elements. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty. Definition at line 172 of file deque.tcc. Referenced by deque::erase().

bool empty | ( |  | ) | const`[inline]`

| Returns true if the deque is empty. (Thus begin() would equal end().) Definition at line 883 of file stl_deque.h.

const_iterator end | ( |  | ) | const`[inline]`

| Returns a read-only (constant) iterator that points one past the last element in the deque. Iteration is done in ordinary element order. Definition at line 795 of file stl_deque.h.

iterator end | ( |  | ) | `[inline]`

| Returns a read/write iterator that points one past the last element in the deque. Iteration is done in ordinary element order. Definition at line 786 of file stl_deque.h. Referenced by deque::back(), deque::deque(), deque::operator=(), and std::operator==().

deque< _Tp, _Alloc >::iterator erase | ( | iterator | __first,
|  | iterator | __last
| ) |

Remove a range of elements.

Parameters:

  | first | Iterator pointing to the first element to be erased.
  | last | Iterator pointing to one past the last element to be erased.

Returns:
  An iterator pointing to the element pointed to by last prior to erasing (or end()).

This function will erase the elements in the range [first,last) and shorten the deque accordingly.

The user is cautioned that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 132 of file deque.tcc.

References deque::clear(), std::copy(), std::copy_backward(), and deque::size().

deque< _Tp, _Alloc >::iterator erase | ( | iterator | __position | ) |

Remove element at given position.

Parameters:

  | position | Iterator pointing to element to be erased.

Returns:
  An iterator pointing to the next element (or end()).

This function will erase the element at the given position and thus shorten the deque by one.

The user is cautioned that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 111 of file deque.tcc.

References std::copy(), std::copy_backward(), deque::pop_back(), and deque::pop_front().

Referenced by deque::operator=(), and deque::resize().

const_reference front | ( |  | ) | const`[inline]`

| Returns a read-only (constant) reference to the data at the first element of the deque. Definition at line 976 of file stl_deque.h. References deque::begin().

reference front | ( |  | ) | `[inline]`

| Returns a read/write reference to the data at the first element of the deque. Definition at line 968 of file stl_deque.h. References deque::begin().

allocator_type get_allocator | ( |  | ) | const`[inline]`

| Get a copy of the memory allocation object. Definition at line 760 of file stl_deque.h. Referenced by deque::deque().

void insert | ( | iterator | __position,
|  | _InputIterator | __first,
|  | _InputIterator | __last
| ) | `[inline]`

Inserts a range into the deque.

Parameters:

  | position | An iterator into the deque.
  | first | An input iterator.
  | last | An input iterator.

This function will insert copies of the data in the range [first,last) into the deque before the location specified by pos. This is known as "range insert."

Definition at line 1126 of file stl_deque.h.

void insert | ( | iterator | __position,
|  | size_type | __n,
|  | const value_type & | __x
| ) | `[inline]`

Inserts a number of copies of given data into the deque.

Parameters:

  | position | An iterator into the deque.
  | n | Number of elements to be inserted.
  | x | Data to be inserted.

This function will insert a specified number of copies of the given data before the location specified by position.

Definition at line 1111 of file stl_deque.h.

deque< _Tp, _Alloc >::iterator insert | ( | iterator | position,
|  | const value_type & | __x
| ) |

Inserts given value into deque before specified iterator.

Parameters:

  | position | An iterator into the deque.
  | x | Data to be inserted.

Returns:
  An iterator that points to the inserted data.

This function will insert a copy of the given value before the specified location.

Definition at line 90 of file deque.tcc.

References deque::push_back(), and deque::push_front().

Referenced by deque::operator=(), and deque::resize().

size_type max_size | ( |  | ) | const`[inline]`

| Returns the size() of the largest possible deque. Definition at line 841 of file stl_deque.h.

deque< _Tp, _Alloc > & operator= | ( | const deque< _Tp, _Alloc > & | __x | ) |

Deque assignment operator.

Parameters:

  | x | A deque of identical element and allocator types.

All the elements of x are copied, but unlike the copy constructor, the allocator object is not copied.

Definition at line 69 of file deque.tcc.

References deque::begin(), std::copy(), deque::end(), deque::erase(), deque::insert(), and deque::size().

const_reference operator[] | ( | size_type | __n | ) | const`[inline]`

Subscript access to the data contained in the deque.

Parameters:

  | n | The index of the element for which data should be accessed.

Returns:
  Read-only (constant) reference to data.

This operator allows for easy, array-style, data access. Note that data access with this operator is unchecked and out_of_range lookups are not defined. (For checked lookups see at().)

Definition at line 914 of file stl_deque.h.

reference operator[] | ( | size_type | __n | ) | `[inline]`

Subscript access to the data contained in the deque.

Parameters:

  | n | The index of the element for which data should be accessed.

Returns:
  Read/write reference to data.

This operator allows for easy, array-style, data access. Note that data access with this operator is unchecked and out_of_range lookups are not defined. (For checked lookups see at().)

Definition at line 899 of file stl_deque.h.

void pop_back | ( |  | ) | `[inline]`

| Removes last element. This is a typical stack operation. It shrinks the deque by one. Note that no data is returned, and if the last element's data is needed, it should be retrieved before pop_back() is called. Definition at line 1077 of file stl_deque.h. Referenced by deque::erase().

void pop_front | ( |  | ) | `[inline]`

| Removes first element. This is a typical stack operation. It shrinks the deque by one. Note that no data is returned, and if the first element's data is needed, it should be retrieved before pop_front() is called. Definition at line 1056 of file stl_deque.h. Referenced by deque::erase().

void push_back | ( | const value_type & | __x | ) | `[inline]`

Add data to the end of the deque.

Parameters:

  | x | Data to be added.

This is a typical stack operation. The function creates an element at the end of the deque and assigns the given data to it. Due to the nature of a deque this operation can be done in constant time.

Definition at line 1035 of file stl_deque.h.

Referenced by deque::insert().

void push_front | ( | const value_type & | __x | ) | `[inline]`

Add data to the front of the deque.

Parameters:

  | x | Data to be added.

This is a typical stack operation. The function creates an element at the front of the deque and assigns the given data to it. Due to the nature of a deque this operation can be done in constant time.

Definition at line 1014 of file stl_deque.h.

Referenced by deque::insert().

const_reverse_iterator rbegin | ( |  | ) | const`[inline]`

| Returns a read-only (constant) reverse iterator that points to the last element in the deque. Iteration is done in reverse element order. Definition at line 813 of file stl_deque.h.

reverse_iterator rbegin | ( |  | ) | `[inline]`

| Returns a read/write reverse iterator that points to the last element in the deque. Iteration is done in reverse element order. Definition at line 804 of file stl_deque.h.

const_reverse_iterator rend | ( |  | ) | const`[inline]`

| Returns a read-only (constant) reverse iterator that points to one before the first element in the deque. Iteration is done in reverse element order. Definition at line 830 of file stl_deque.h.

reverse_iterator rend | ( |  | ) | `[inline]`

| Returns a read/write reverse iterator that points to one before the first element in the deque. Iteration is done in reverse element order. Definition at line 822 of file stl_deque.h.

void resize | ( | size_type | new_size | ) | `[inline]`

Resizes the deque to the specified number of elements.

Parameters:

  | new_size | Number of elements the deque should contain.

This function will resize the deque to the specified number of elements. If the number is smaller than the deque's current size the deque is truncated, otherwise the deque is extended and new elements are default-constructed.

Definition at line 875 of file stl_deque.h.

References deque::resize().

void resize | ( | size_type | __new_size,
|  | const value_type & | __x
| ) | `[inline]`

Resizes the deque to the specified number of elements.

Parameters:

  | new_size | Number of elements the deque should contain.
  | x | Data with which new elements should be populated.

This function will resize the deque to the specified number of elements. If the number is smaller than the deque's current size the deque is truncated, otherwise the deque is extended and new elements are populated with given data.

Definition at line 856 of file stl_deque.h.

References deque::erase(), deque::insert(), and deque::size().

Referenced by deque::resize().

size_type size | ( |  | ) | const`[inline]`

| Returns the number of elements in the deque. Definition at line 836 of file stl_deque.h. Referenced by deque::erase(), deque::operator=(), std::operator==(), and deque::resize().

void swap | ( | deque< _Tp, _Alloc > & | __x | ) | `[inline]`

Swaps data with another deque.

Parameters:

  | x | A deque of the same element and allocator types.

This exchanges the elements between two deques in constant time. (Four pointers, so it should be quite fast.) Note that the global std::swap() function is specialized such that std::swap(d1,d2) will feed to this function.

Definition at line 1179 of file stl_deque.h.

References std::swap().

Referenced by std::swap().

The documentation for this class was generated from the following files:

- stl_deque.h
- deque.tcc